/*
 * @(#)ErrorPanel.java     2.00 2001/01/01
 *
 */

import java.awt.*;

/**
 * Panel pro zobrazeni chybovych hlasek pri vyjimkach
 *
 * @version 2.00 2001/01/01
 * @author Martin Kot
 */
public class ErrorPanel extends Panel {
    /** Konstanta pro oznaceni chyby pri nenalezeni souboru */
    public static final int FILE_NOT_FOUND = 0;
    /** Konstanta pro oznaceni chyby pri praci se souborem */
    public static final int IO_EXCEPTION = 1;
    /** Konstanta pro oznaceni chyby pri nedostatku slov v souboru */
    public static final int NOT_ENOUGH_WORDS = 2;
  
    /** Konstanta pro oznaceni chyby pri nedostatku slov v souboru */
    public static final int NO_LANGS = 3;
    /** Konstanta pro oznaceni chyby pri nemoznosti zmenit jazyk */
    public static final int CHANGE_LANG = 4;
    /** Texty pro chybove hlasky */
    protected static String[] messages= {"File with words not found",
                               "Error during reading file",
                               "No more words in file",
                               "XML file contains no language",
                               "Can not change language"};

    /**
     * Konstruktor
     *
     * @param text oznaceni chybove hlasky, ktera ma byt zobrazena
     *
     */
    public ErrorPanel(int text){
        Label label = new Label(messages[text]);
        add(label);
        label.setFont(new Font("Helvetica",Font.BOLD,24));
        label.setAlignment(Label.LEFT);
        label.setForeground(Color.red);
    }

    /**
     * Konstruktor bez parametru. Zobrazi se chybova hlaska pro nenalezeny
     * soubor
     *
     */
    public ErrorPanel(){
        this(FILE_NOT_FOUND);
    }
}
