/*
 * @(#)GallowsApplet.java       2.0 2000/12/30
 *
 */


import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.util.*;

/**
 * Applet - Hra sibenice
 *
 * @version 2.00 2000/12/30
 * @author Martin Kot
 */

public class GallowsApplet extends Applet {

    /** Jmeno souboru, ze ktereho budou brany slova */
    public static String FILE_NAME = "word.txt";

    /** Texty v okne po skonceni hry */
    protected static String[][] endMessages= {{"You won", "The word was"},
                                              {"You hang", "The word was"}};
    /** Symbolicka konstanta, ktera vybira vitezne texty z "endMessages" */
    protected static final int WIN = 0;
    /** Symbolicka konstanta, ktera vybira texty z "endMessages" pro
     *  prohranou
     */
    protected static final int LOST = 1;



    //Rozmery objektu pro rozhrani
    /** Rozmery pro label oznamujici vyhru nebo prohru */
    protected static Rectangle LOST_LABEL_DIM
        = new Rectangle(20, 50, 280, 40);
    /** Rozmery pro label zobrazujici hlasku o hadanem slove po konci hry*/
    protected static Rectangle ANSVER_LABEL1_DIM =
        new Rectangle(20, 90, 280, 30);
    /** Rozmery pro label zobrazujici hadane slovo po skonceni hry*/
    protected static Rectangle ANSVER_LABEL2_DIM =
        new Rectangle(20, 120, 280, 30);
    /** Rozmery pro panel s nabidkou pokracovani po skonceni hry */
    protected static Rectangle PANEL_AGAIN_DIM
        = new Rectangle(5, 160, 440, 50);
    /** Rozmery pro applet zobrazujici obrazky po skonceni hry*/
    protected static Rectangle IMAGES_DIM = new Rectangle(320, 50, 105, 100);
    /** Rozmery pro panel obsahujici hadane slovo, obrazek a pocet pokusu */
    protected static Rectangle PANEL_LABELS_DIM
        = new Rectangle(5, 5, 440, 115);
    /** Rozmery pro label zobrazujici hadane slovo */
    protected static Rectangle LABEL_WORD_DIM
        = new Rectangle(5, 20, 260, 30);
    /** Rozmery pro label zobrazujici aktualni jazyk */
    protected static Rectangle LABEL_LANG_DIM
        = new Rectangle(5, 50, 260, 30);
    /** Rozmery pro checkbox pro voleni narodnich znaku */
    protected static Rectangle CBOX_ASCII_DIM
        = new Rectangle(5, 80, 120, 30);
    /** Rozmery pro  label zobrazujici pocet chybnych pokusu */
    protected static Rectangle LABEL_ATTEMP_DIM 
        = new Rectangle(380, 45, 60, 40);
    /** Rozmery pro label zobrazujici cast nadpisu pro pocet pokusu */
    protected static Rectangle WRONG_DIM = new Rectangle(380, 20, 60, 10);
    /** Rozmery pro label zobrazujici cast nadpisu pro pocet pokusu */
    protected static Rectangle ATTEMPS_DIM = new Rectangle(380, 30, 60, 10);
    /** Rozmery pro applet zobrazujici obrazky behem hry*/
    protected static Rectangle IMAGES_GAME_DIM =
        new Rectangle(270, 10, 105, 105);
    /** Rozmery pro tlaciko pro pokracovani po skonceni hry*/
    protected static Rectangle BUTTON_YES_DIM
        = new Rectangle(130, 1, 60, 20);
    /** Rozmery pro tlaciko pro konec po skonceni hry*/
    protected static Rectangle BUTTON_NO_DIM = new Rectangle(250, 1, 60, 20);
    /** Sirka hlavniho okna*/
    protected static int FRAME_HEIGHT = 230 ;
    /** Vyska hlavniho okna */
    protected static int FRAME_WIDTH = 465;


    /** Nazvy souboru s obrazky */
    private static String imagesNames[] = {"images/pic1.gif",
                                           "images/pic2.gif",
                                           "images/pic3.gif",
                                           "images/pic4.gif",
                                           "images/pic5.gif",
                                           "images/pic6.gif",
                                           "images/pic7.gif",
                                           "images/pic8.gif",
                                           "images/pic9.gif",
                                           "images/pic10.gif"};
    
    /** Hlavni okno */
    protected Frame fr;
    /** Label zobrazujici hadane slovo */
    protected Label labelWord;
    /** Label zobrazujici jazyk */
    protected Label labelLang;
    /** Check box pro variantu slov */
    protected Checkbox asciiCBox;
    /** Label zobrazujici pocet chybnych pokusu */
    protected Label labelAttemp;
    /** Hra sibenice, k niz tento objekt dela rozhrani */
    protected GallowsGame galGame;
    /** Panel s tlacitky s pismeny */
    protected LetterButtonsPanel panelButtons;
    /** Pole tlacitek s pismeny */
    protected GallowsImagesApplet images;
    /** Tlacitko pro novou hru po skonceni stare */
    protected Button buttonYes;

    /** Nazev aktualniho jazyka */
    protected String aktLang;	
    /** Observer stavu hry sibenice */
    protected Observer galGameObserver;

    /** Flag urcujici, zda byla osetrovana vyjimka (tedy zobrazeno chybove
     * okno
     */
    protected boolean errorFlag = false;

    /** Posluchac udalosti tlacitek a menu */
    protected ActionListener actListener;

    /** Trida nacitajici jazyky a slova */
    protected Languages languages;

    /** Jsou povoleny narodni slova obsahujici narodni znaky */
    protected boolean ascii = false;

    /**
     * Nastavi okno na oznameni o vyhre nebo prohre
     *
     * @param result hodnota "WIN" pro vyhranou hru
     *               hodnota "LOST" pro prohranou hru
     *
     */
    protected void setEndConf(int result) {
        fr.removeAll();
        fr.setLayout(null);

        //Nastavi oznameni o vyhre nebo prohre
        Label lostLabel = new Label(endMessages[result][0]);
        lostLabel.setFont(new Font("Helvetica", Font.BOLD, 35));
        lostLabel.setAlignment(Label.CENTER);
        if(result == WIN) {
            lostLabel.setForeground(Color.green.darker());
        }
        else {
            lostLabel.setForeground(Color.red);
        } 
        fr.add(lostLabel);
        lostLabel.setBounds(LOST_LABEL_DIM);

        //Zobrazi spravne reseni
        Label answerLabel1 = new Label(endMessages[result][1]);
        answerLabel1.setFont(new Font("Courier", Font.BOLD, 15));
        answerLabel1.setAlignment(Label.CENTER);
        answerLabel1.setForeground(Color.blue);
        fr.add(answerLabel1);
        answerLabel1.setBounds(ANSVER_LABEL1_DIM);

        Label answerLabel2 = new Label(galGame.getAssignment());
        answerLabel2.setFont(new Font("Courier", Font.BOLD, 24));
        answerLabel2.setAlignment(Label.CENTER);
        answerLabel2.setForeground(Color.blue);
        fr.add(answerLabel2);
        answerLabel2.setBounds(ANSVER_LABEL2_DIM);

        //Prida panel s nabidkou pokracovani
        fr.add(makePanelAgain());

        //Prida obrazek 
        fr.add(images);
        images.setBounds(IMAGES_DIM);

        buttonYes.requestFocus();
        fr.show();
    }


    /**
     * Nastavi okno na hru
     *
     */
    protected void setGameConf() {
        fr.removeAll();
        fr.setLayout(new BorderLayout(5, 5));

        Panel panelLabels = new Panel();
        panelLabels.setLayout(null);
        panelLabels.setBounds(PANEL_LABELS_DIM);

        //Utvoreni labelu zobrazujiciho hledane slovo
        labelWord = new Label(galGame.getFound());
        labelWord.setBounds(LABEL_WORD_DIM);
        labelWord.setFont(new Font("Courier", Font.BOLD, 21));
        labelWord.setAlignment(Label.LEFT);
        labelWord.setForeground(Color.green.darker());
        panelLabels.add(labelWord);

        //Utvoreni labelu zobrazujiciho hledane slovo
        labelLang = new Label("Language: " + aktLang);
        labelLang.setBounds(LABEL_LANG_DIM);
        labelLang.setFont(new Font("Courier", Font.BOLD, 12));
        labelLang.setAlignment(Label.LEFT);
        labelLang.setForeground(Color.black);
        panelLabels.add(labelLang);
	
	asciiCBox = new Checkbox("Replaced letters",ascii);
        asciiCBox.setBounds(CBOX_ASCII_DIM);
	asciiCBox.addItemListener(
            new ItemListener(){
                public void itemStateChanged(ItemEvent e) {
                    ascii = asciiCBox.getState();
                    galGame.setAscii(ascii);
		}
	    });            
	panelLabels.add(asciiCBox);

        //Vytvoreni labelu zobrazujiciho pocet chybnych pokusu
        labelAttemp = new Label("0");
        labelAttemp.setFont(new Font("Helvetica", Font.BOLD, 40));
        labelAttemp.setAlignment(Label.CENTER);
        labelAttemp.setForeground(Color.red);
        panelLabels.add(labelAttemp);
        labelAttemp.setBounds(LABEL_ATTEMP_DIM);


        //Vytvoreni nadpisu pro pocet chybnych pokusu
        Label wrong = new Label("WRONG");
        wrong.setAlignment(Label.CENTER);
        panelLabels.add(wrong);
        wrong.setBounds(WRONG_DIM);
        Label attemps = new Label("ATTEMPS");
        attemps.setAlignment(Label.CENTER);
        panelLabels.add(attemps);
        attemps.setBounds(ATTEMPS_DIM);

        //Pridani appletu na zobrazovani obrazku
        images = new GallowsImagesApplet(galGame, readImages());
        panelLabels.add(images);
        images.setBounds(IMAGES_GAME_DIM);

        fr.add("North",panelLabels);
        fr.add("Center",panelButtons);
        fr.show();
    }


    /**
     * Nastavi okno na chybovou hlasku po ocekavane vyjimce
     *
     */
    protected void showError(int type) {
        errorFlag = true;
        fr.removeAll();
        fr.setLayout(new GridLayout(1, 1, 0, 0));
        fr.add("Center",new ErrorPanel(type));
        fr.show();
    }


    /**
     * Vytvori panel s nabidkou pokracovani po konci hry a prislusne tlacitka
     *
     * @return vytvoreny panel s nabidkou pokracovani a tlacitky
     *
     */
   protected Panel makePanelAgain() {
        Panel panelAgain = new Panel();
        panelAgain.setLayout(new BorderLayout());

        //Vytvori label s nabidkou pokracovani
        Label labelAgain = new Label("Play again?");
        labelAgain.setAlignment(Label.CENTER);
        panelAgain.add("North", labelAgain);

        //Vytvori tlacitka pro volbu pokracovani
        buttonYes = new Button("Yes");
        buttonYes.setBounds(BUTTON_YES_DIM);
        buttonYes.addActionListener(actListener);
        Button buttonNo = new Button("No");
        buttonNo.setBounds(BUTTON_NO_DIM);
        buttonNo.addActionListener(actListener);

        Panel panelYesNo = new Panel();
        panelYesNo.setLayout(null);
        panelYesNo.add(buttonYes);
        panelYesNo.add(buttonNo);
        panelAgain.add("Center", panelYesNo);
        panelAgain.setBounds(PANEL_AGAIN_DIM);
        return panelAgain;
   }




    /**
     * Nacte obrazky ze souboru. Jmena techto souboru jsou v poli imagesNames
     *
     * @return pole nactenych obrazku
     *
     */
    protected Image[] readImages() {
        Image images[] = new Image[imagesNames.length];
        for(int i = 0; i < imagesNames.length; i++) {
            images[i] = getImage(getCodeBase(), imagesNames[i]);
        }
        return images;
    }


    /**
     * Konec hry
     *
     */
    public void endGame() {
        fr.dispose();
        destroy();
    }


    /**
     * Zobrazi hadane slovo a deaktivuje tlacitka
     *
     */
    public void showSolution() {
        labelWord.setText(galGame.getAssignment());
        panelButtons.setButtons(false);
    }

    /**
     * Zmeni mnozinu hadanych slov na vybrany jazyk
     *
     */
    public void changeLanguage(String actionCommand) {
      if(actionCommand.compareTo(aktLang)!=0){
        panelButtons.setButtons(true);
        aktLang = actionCommand;
        if (galGame.isLost() || galGame.isDone() ||
                errorFlag == true) {
            setGameConf();
            errorFlag = false;
        }
        try {
          galGame.changeLanguage(languages.getWords(actionCommand)
		,languages.getAsciiWords());
        } catch (Exception e) {
          showError(ErrorPanel.CHANGE_LANG);
        }
	labelLang.setText("Language: " + aktLang);
        panelButtons.requestButtonFocus();
      }
    }

    /**
     * Zmeni hadane slovo
     *
     */
    public void changeGuessedWord() {
        panelButtons.setButtons(true);
        if (galGame.isLost() || galGame.isDone() ||
                errorFlag == true) {
            setGameConf();
            errorFlag = false;
        }
        try {
            galGame.newWord();
        } catch (FileNotFoundException e) {
            showError(ErrorPanel.FILE_NOT_FOUND);
        } catch (IOException e) {
            showError(ErrorPanel.IO_EXCEPTION);
        } catch (NotEnoughWordsException e) {
            showError(ErrorPanel.NOT_ENOUGH_WORDS);
        }
        panelButtons.requestButtonFocus();
    }


    /**
     * Inicializacni metoda appletu
     *
     */
    public void init() {
        Dimension screenSize, dialogSize;


        //Vytvori pro hru nove okno
        fr = new Frame("Gallows Game");

        //Vytvoreni posluchace na obsluhu uzavreni okna
        fr.addWindowListener(
            new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    fr.dispose(); 
                 }
             });

        //Zmena velikosti okna a jeho vycentrovani na obrazovce
        fr.setSize(new Dimension(FRAME_WIDTH, FRAME_HEIGHT));
        fr.setResizable(false);
        screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        dialogSize = fr.getSize();
        fr.setLocation((screenSize.width - dialogSize.width) / 2,
                (screenSize.height - dialogSize.height) / 2);
        try {
          languages = new Languages(getCodeBase());
        } catch (java.io.IOException e) {
          System.err.println("Error by parsing XML file\n"+e);
          this.stop();
        } catch (org.xml.sax.SAXException e) {
          System.err.println("Error by parsing XML file\n"+e);
          this.stop();
        } catch (Exception e) {
           System.err.println(e);
        }
        //Nejsou-li zadne jazyky k dispozici
	if (languages.getLanguages().size() == 0){
            showError(ErrorPanel.NO_LANGS);  
        }

        //Vytvoreni hry sibenice 
        try {
            aktLang = (String) languages.getLanguages().elementAt(0);
            galGame = new GallowsGame(languages.getWords(aktLang)
                 ,languages.getAsciiWords());
        } catch (FileNotFoundException e) {
            fr.setVisible(true);
            showError(ErrorPanel.FILE_NOT_FOUND);
            stop();
        } catch (IOException e) {
            fr.setVisible(true);
            showError(ErrorPanel.IO_EXCEPTION);
            System.err.println("Error by reading file");
            stop();
        } catch (NotEnoughWordsException e) {
            fr.setVisible(true);
            showError(ErrorPanel.NOT_ENOUGH_WORDS);
            stop();
        } catch (org.xml.sax.SAXException e) {
           System.err.println("Error by parsing XML file\n"+e);
           stop();
        } catch (Exception e) {
           System.err.println(e);
           stop();
        }

        if(galGame != null) {
            //Pridani pozorovatele hry 
            galGameObserver = new Observer() {
                    public void update(Observable o, Object arg) {
                        GameState state = (GameState) arg;
                        if (state.isLost()) {
                            setEndConf(LOST);
                        }
                        else if (state.isDone()) {
                            setEndConf(WIN);
                        }
                        else {
                            labelWord.setText(state.getFound());
                            labelAttemp.setText(
                                new Integer(state.attemp()).toString());
                        }
                    }
                };
            galGame.addObserver(galGameObserver);
           
            //Vytvoreni posluchace na obsluhu akci od tlacitek po konci hry
            actListener =
                new ActionListener() {
                    public void actionPerformed (ActionEvent ae) {
                        if (ae.getActionCommand() == "Yes") {
                            changeGuessedWord();
                        }
                        else if (ae.getActionCommand() == "No" ) {
                            endGame();
                        }
                    }
                };

    

            //Vytvori panel s tlacitky s pismeny abecedy
            panelButtons = new LetterButtonsPanel(galGame);

            //Nastavi menu pro frame hry
            fr.setMenuBar(new GallowsMenu(this,languages));

            setGameConf();
            fr.setVisible(true);
        }
    }
}




